Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ppm3d.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ppm3d.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ppm3d.F	(revision 5101)
@@ -24,5 +24,5 @@
 C
 C Purpose: given horizontal winds on  a hybrid sigma-p surfaces,
-C          one call to tpcore updates the 3-D mixing ratio
+C          one CALL to tpcore updates the 3-D mixing ratio
 C          fields one time step (NDT). [vertical mass flux is computed
 C          internally consistent with the discretized hydrostatic mass
@@ -355,8 +355,8 @@
       if(IGD==0) then
 C Compute analytic cosine at cell edges
-            call cosa(cosp,cose,JNP,PI,DP)
+            CALL cosa(cosp,cose,JNP,PI,DP)
       else
 C Define cosine consistent with GEOS-GCM (using dycore2.0 or later)
-            call cosc(cosp,cose,JNP,PI,DP)
+            CALL cosc(cosp,cose,JNP,PI,DP)
       endif
 C
@@ -455,5 +455,5 @@
       if(IGD==0) then
 C Convert winds on A-Grid to Courant # on C-Grid.
-      call A2C(U(1,1,k),V(1,1,k),IMR,JMR,j1,j2,CRX,CRY,dtdx5,DTDY5)
+      CALL A2C(U(1,1,k),V(1,1,k),IMR,JMR,j1,j2,CRX,CRY,dtdx5,DTDY5)
       else
 C Convert winds on C-grid to Courant #
@@ -674,6 +674,6 @@
 		jad = 1
 	endif
-      call xadv(IMR,JNP,j1,j2,wk1(1,1,2),UA,JS,JN,IML,DC2,iad)
-      call yadv(IMR,JNP,j1,j2,wk1(1,1,1),VA,PV,W,jad)
+      CALL xadv(IMR,JNP,j1,j2,wk1(1,1,2),UA,JS,JN,IML,DC2,iad)
+      CALL yadv(IMR,JNP,j1,j2,wk1(1,1,1),VA,PV,W,jad)
       do j=1,JNP
       do i=1,IMR
@@ -683,8 +683,8 @@
       endif
 C
-      call xtp(IMR,JNP,IML,j1,j2,JN,JS,PU,DQ(1,1,k,IC),wk1(1,1,2)
+      CALL xtp(IMR,JNP,IML,j1,j2,JN,JS,PU,DQ(1,1,k,IC),wk1(1,1,2)
      &        ,CRX,fx1,xmass,IORD)
 
-      call ytp(IMR,JNP,j1,j2,acosp,RCAP,DQ(1,1,k,IC),wk1(1,1,1),CRY,
+      CALL ytp(IMR,JNP,j1,j2,acosp,RCAP,DQ(1,1,k,IC),wk1(1,1,1),CRY,
      &  DC2,ymass,WK1(1,1,3),wk1(1,1,4),WK1(1,1,5),WK1(1,1,6),JORD)
 C
@@ -746,9 +746,9 @@
 C****6***0*********0*********0*********0*********0*********0**********72
    
-      call FZPPM(IMR,JNP,NLAY,j1,DQ(1,1,1,IC),W,Q(1,1,1,IC),WK1,DPI,
+      CALL FZPPM(IMR,JNP,NLAY,j1,DQ(1,1,1,IC),W,Q(1,1,1,IC),WK1,DPI,
      &           DC2,CRX,CRY,PU,PV,xmass,ymass,delp1,KRD)
 C
     
-      if(fill) call qckxyz(DQ(1,1,1,IC),DC2,IMR,JNP,NLAY,j1,j2,
+      if(fill) CALL qckxyz(DQ(1,1,1,IC),DC2,IMR,JNP,NLAY,j1,j2,
      &                     cosp,acosp,.false.,IC,NSTEP)
 C
@@ -921,11 +921,11 @@
 C****6***0*********0*********0*********0*********0*********0**********72
 C Top & Bot always monotonic
-      call lmtppm(flux(1,1),A6(1,1),AR(1,1),AL(1,1),wk1(1,1),IMR,0)
-      call lmtppm(flux(1,NLAY),A6(1,NLAY),AR(1,NLAY),AL(1,NLAY),
+      CALL lmtppm(flux(1,1),A6(1,1),AR(1,1),AL(1,1),wk1(1,1),IMR,0)
+      CALL lmtppm(flux(1,NLAY),A6(1,NLAY),AR(1,NLAY),AL(1,NLAY),
      &            wk1(1,NLAY),IMR,0)
 C
 C Interior depending on KORD
       if(LMT<=2)
-     &  call lmtppm(flux(1,2),A6(1,2),AR(1,2),AL(1,2),wk1(1,2),
+     &  CALL lmtppm(flux(1,2),A6(1,2),AR(1,2),AL(1,2),wk1(1,2),
      &              IMR*(NLAY-2),LMT)
 C
@@ -1004,5 +1004,5 @@
       END DO
       ELSE
-      call xmist(IMR,IML,Qtmp,DC)
+      CALL xmist(IMR,IML,Qtmp,DC)
       DC(0) = DC(IMR)
 C
@@ -1013,5 +1013,5 @@
       END DO
       else
-      call fxppm(IMR,IML,UC(1,j),Qtmp,DC,fx1,IORD)
+      CALL fxppm(IMR,IML,UC(1,j),Qtmp,DC,fx1,IORD)
       endif
 C
@@ -1041,5 +1041,5 @@
       END DO
       ELSE
-      call xmist(IMR,IML,Qtmp,DC)
+      CALL xmist(IMR,IML,Qtmp,DC)
 C
       do i=-IML,0
@@ -1132,5 +1132,5 @@
       END DO
 C
-      if(LMT<=2) call lmtppm(DC(1),A6(1),AR(1),AL(1),P(1),IMR,LMT)
+      if(LMT<=2) CALL lmtppm(DC(1),A6(1),AR(1),AL(1),P(1),IMR,LMT)
 C
       AL(0) = AL(IMR)
@@ -1189,9 +1189,9 @@
       else
    
-      call ymist(IMR,JNP,j1,P,DC2,4)
+      CALL ymist(IMR,JNP,j1,P,DC2,4)
 C
       if(JORD<=0 .or. JORD>=3) then
    
-      call fyppm(VC,P,DC2,fx,IMR,JNP,j1,j2,A6,AR,AL,JORD)
+      CALL fyppm(VC,P,DC2,fx,IMR,JNP,j1,j2,A6,AR,AL,JORD)
     
       else
@@ -1384,5 +1384,5 @@
       END DO
 C
-      if(LMT<=2) call lmtppm(DC(1,j11),A6(1,j11),AR(1,j11)
+      if(LMT<=2) CALL lmtppm(DC(1,j11),A6(1,j11),AR(1,j11)
      &                       ,AL(1,j11),P(1,j11),len,LMT)
 C
@@ -1761,11 +1761,11 @@
       L = 1
 	icr = 1
-      call filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
+      CALL filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
       if(ipy==0) goto 50
-      call filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
+      CALL filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
       if(ipx==0) goto 50
 C
       if(cross) then
-      call filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
+      CALL filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
       endif
       if(icr==0) goto 50
@@ -1784,10 +1784,10 @@
       icr = 1
 C
-      call filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
+      CALL filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
       if(ipy==0) goto 225
-      call filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
+      CALL filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
       if(ipx==0) go to 225
       if(cross) then
-      call filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
+      CALL filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
       endif
       if(icr==0) goto 225
@@ -1815,10 +1815,10 @@
       L = NLAY
 C
-      call filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
+      CALL filns(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,ipy,tiny)
       if(ipy==0) goto 911
-      call filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
+      CALL filew(q(1,1,L),qtmp,IMR,JNP,j1,j2,ipx,tiny)
       if(ipx==0) goto 911
 C
-      call filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
+      CALL filcr(q(1,1,L),IMR,JNP,j1,j2,cosp,acosp,icr,tiny)
       if(icr==0) goto 911
 C
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/prather.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/prather.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/prather.F	(revision 5101)
@@ -147,5 +147,5 @@
 c-----------------------------------------------------------
        do indice =1,nt
-       call advxp( limit,0.5*dt,pbaru,sm,s0,sx,sy,sz
+       CALL advxp( limit,0.5*dt,pbaru,sm,s0,sx,sy,sz
      .             ,sxx,sxy,sxz,syy,syz,szz,1 )
         END DO
@@ -157,5 +157,5 @@
         enddo
 c---------------------------------------------------------
-       call advyp( limit,.5*dt*nt,pbarv,sm,s0,sx,sy,sz
+       CALL advyp( limit,.5*dt*nt,pbarv,sm,s0,sx,sy,sz
      .             ,sxx,sxy,sxz,syy,syz,szz,1 )
 c---------------------------------------------------------
@@ -174,5 +174,5 @@
           enddo
        enddo
-       call advzp( limit,dt*nt,w,sm,s0,sx,sy,sz 
+       CALL advzp( limit,dt*nt,w,sm,s0,sx,sy,sz
      .             ,sxx,sxy,sxz,syy,syz,szz,1 )
         do l=1,llm
@@ -186,5 +186,5 @@
 
 c---------------------------------------------------------
-       call advyp( limit,.5*dt*nt,pbarv,sm,s0,sx,sy,sz
+       CALL advyp( limit,.5*dt*nt,pbarv,sm,s0,sx,sy,sz
      .             ,sxx,sxy,sxz,syy,syz,szz,1 )
 c---------------------------------------------------------
@@ -204,5 +204,5 @@
        ENDDO
        do indice=1,nt
-       call advxp( limit,0.5*dt,pbaru,sm,s0,sx,sy,sz
+       CALL advxp( limit,0.5*dt,pbaru,sm,s0,sx,sy,sz
      .             ,sxx,sxy,sxz,syy,syz,szz,1 )
         END DO
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/rotatf.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/rotatf.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/rotatf.F	(revision 5101)
@@ -9,5 +9,5 @@
 c     a tous les niveaux d'1 vecteur de comp. x et y ..
 c       x  et  y etant des composantes  covariantes  ...
-c     Only difference with rotat: call to filtreg.
+c     Only difference with rotat: CALL to filtreg.
 c********************************************************************
 c   klevel, x  et y   sont des arguments d'entree pour le s-prog
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ugeostr.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ugeostr.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/ugeostr.F90	(revision 5101)
@@ -48,5 +48,5 @@
      ENDDO
   ENDDO
-  call dump2d(jjm,llm,um,'Vent-u geostrophique')
+  CALL dump2d(jjm,llm,um,'Vent-u geostrophique')
 
   !   calcul des champ de vent:
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/write_grads_dyn.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/write_grads_dyn.h	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/write_grads_dyn.h	(revision 5101)
@@ -5,5 +5,5 @@
 
          string10='dyn'
-         call inigrads(1,iip1
+         CALL inigrads(1,iip1
      s  ,rlonv,180./pi,-180.,180.,jjp1,rlatu,-90.,90.,180./pi
      s  ,llm,presnivs,1.
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writedynav.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writedynav.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writedynav.F90	(revision 5101)
@@ -6,6 +6,6 @@
   USE ioipsl
 #endif
-  USE infotrac, ONLY : nqtot
-  use com_io_dyn_mod, only : histaveid, histvaveid, histuaveid
+  USE infotrac, ONLY: nqtot
+  use com_io_dyn_mod, ONLY: histaveid, histvaveid, histuaveid
   USE comconst_mod, ONLY: cpp
   USE temps_mod, ONLY: itau_dyn
@@ -71,5 +71,5 @@
 
   ! Passage aux composantes naturelles du vent
-  call covnat(llm, ucov, vcov, unat, vnat)
+  CALL covnat(llm, ucov, vcov, unat, vnat)
 
   !  Appels a histwrite pour l'ecriture des variables a sauvegarder
@@ -77,15 +77,15 @@
   !  Vents U 
 
-  call histwrite(histuaveid, 'u', itau_w, unat,  &
+  CALL histwrite(histuaveid, 'u', itau_w, unat,  &
        iip1*jjp1*llm, ndexu)
 
   !  Vents V
 
-  call histwrite(histvaveid, 'v', itau_w, vnat,  &
+  CALL histwrite(histvaveid, 'v', itau_w, vnat,  &
        iip1*jjm*llm, ndexv)
 
   !  Temperature potentielle moyennee
 
-  call histwrite(histaveid, 'theta', itau_w, teta,  &
+  CALL histwrite(histaveid, 'theta', itau_w, teta,  &
        iip1*jjp1*llm, ndexu)
 
@@ -95,10 +95,10 @@
      tm(ii) = teta(ii) * ppk(ii)/cpp
   enddo
-  call histwrite(histaveid, 'temp', itau_w, tm,  &
+  CALL histwrite(histaveid, 'temp', itau_w, tm,  &
        iip1*jjp1*llm, ndexu)
 
   !  Geopotentiel
 
-  call histwrite(histaveid, 'phi', itau_w, phi,  &
+  CALL histwrite(histaveid, 'phi', itau_w, phi,  &
        iip1*jjp1*llm, ndexu)
 
@@ -106,5 +106,5 @@
 
   !  DO iq=1, nqtot
-  !       call histwrite(histaveid, tracers(iq)%longName, itau_w, &
+  !       CALL histwrite(histaveid, tracers(iq)%longName, itau_w, &
   !                   q(:, :, iq), iip1*jjp1*llm, ndexu)
   ! enddo
@@ -112,19 +112,19 @@
   !  Masse
 
-  call histwrite(histaveid, 'masse', itau_w, masse,  &
+  CALL histwrite(histaveid, 'masse', itau_w, masse,  &
        iip1*jjp1*llm, ndexu)
 
   !  Pression au sol
 
-  call histwrite(histaveid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
+  CALL histwrite(histaveid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
 
   ! Geopotentiel au sol
 
-  ! call histwrite(histaveid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
+  ! CALL histwrite(histaveid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
 
   if (ok_sync) then
-     call histsync(histaveid)
-     call histsync(histvaveid)
-     call histsync(histuaveid)
+     CALL histsync(histaveid)
+     CALL histsync(histvaveid)
+     CALL histsync(histuaveid)
   ENDIF
 
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writehist.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writehist.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/writehist.F	(revision 5101)
@@ -7,6 +7,6 @@
       USE ioipsl
 #endif
-      USE infotrac, ONLY : nqtot
-      use com_io_dyn_mod, only : histid,histvid,histuid
+      USE infotrac, ONLY: nqtot
+      use com_io_dyn_mod, ONLY: histid,histvid,histuid
       USE temps_mod, ONLY: itau_dyn
       
@@ -72,5 +72,5 @@
       itau_w = itau_dyn + time
 !  Passage aux composantes naturelles du vent
-      call covnat(llm, ucov, vcov, unat, vnat)
+      CALL covnat(llm, ucov, vcov, unat, vnat)
 C
 C  Appels a histwrite pour l'ecriture des variables a sauvegarder
@@ -78,10 +78,10 @@
 C  Vents U
 C
-      call histwrite(histuid, 'u', itau_w, unat, 
+      CALL histwrite(histuid, 'u', itau_w, unat,
      .               iip1*jjp1*llm, ndexu)
 C
 C  Vents V
 C
-      call histwrite(histvid, 'v', itau_w, vnat, 
+      CALL histwrite(histvid, 'v', itau_w, vnat,
      .               iip1*jjm*llm, ndexv)
 
@@ -89,10 +89,10 @@
 C  Temperature potentielle
 C
-      call histwrite(histid, 'teta', itau_w, teta, 
+      CALL histwrite(histid, 'teta', itau_w, teta,
      .                iip1*jjp1*llm, ndexu)
 C
 C  Geopotentiel
 C
-      call histwrite(histid, 'phi', itau_w, phi, 
+      CALL histwrite(histid, 'phi', itau_w, phi,
      .                iip1*jjp1*llm, ndexu)
 C
@@ -100,5 +100,5 @@
 C
 !        DO iq=1,nqtot
-!          call histwrite(histid, tracers(iq)%longName, itau_w, 
+!          CALL histwrite(histid, tracers(iq)%longName, itau_w,
 !     .                   q(:,:,iq), iip1*jjp1*llm, ndexu)
 !        enddo
@@ -106,20 +106,20 @@
 C  Masse
 C
-      call histwrite(histid,'masse',itau_w, masse,iip1*jjp1*llm,ndexu)
+      CALL histwrite(histid,'masse',itau_w, masse,iip1*jjp1*llm,ndexu)
 C
 C  Pression au sol
 C
-      call histwrite(histid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
+      CALL histwrite(histid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-!      call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
+!      CALL histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
 C
       if (ok_sync) then
-        call histsync(histid)
-        call histsync(histvid)
-        call histsync(histuid)
+        CALL histsync(histid)
+        CALL histsync(histvid)
+        CALL histsync(histuid)
       endif
 #else
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/abort_gcm.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/abort_gcm.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/abort_gcm.F	(revision 5101)
@@ -30,15 +30,15 @@
 #ifdef CPP_IOIPSL
 c$OMP MASTER
-      call histclo
-      call restclo
+      CALL histclo
+      CALL restclo
       if (MPI_rank == 0) then
-         call getin_dump
+         CALL getin_dump
       endif
 c$OMP END MASTER
 #endif
-c     call histclo(2)
-c     call histclo(3)
-c     call histclo(4)
-c     call histclo(5)
+c     CALL histclo(2)
+c     CALL histclo(3)
+c     CALL histclo(4)
+c     CALL histclo(5)
       write(lunout,*) 'Stopping in ', modname
       write(lunout,*) 'Reason = ',message
@@ -50,5 +50,5 @@
         if (using_mpi) THEN
 C$OMP CRITICAL (MPI_ABORT_GCM)
-          call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
+          CALL MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
 C$OMP END CRITICAL (MPI_ABORT_GCM)
         else
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advect_new_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advect_new_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/advect_new_loc.f90	(revision 5101)
@@ -0,0 +1,293 @@
+! $Header$
+
+SUBROUTINE advect_new_loc(ucov, vcov, teta, w, massebx, masseby, &
+        du, dv, dteta)
+  USE parallel_lmdz
+  USE write_field_loc
+  USE advect_new_mod
+  USE comconst_mod, ONLY: daysec
+  USE logic_mod, ONLY: conser
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
+  IMPLICIT NONE
+  !=======================================================================
+  !
+  !   Auteurs:  P. Le Van , Fr. Hourdin  .
+  !   -------
+  !
+  !   Objet:
+  !   ------
+  !
+  !   *************************************************************
+  !   .... calcul des termes d'advection vertic.pour u,v,teta,q ...
+  !   *************************************************************
+  !    ces termes sont ajoutes a du,dv,dteta et dq .
+  !  Modif F.Forget 03/94 : on retire q de advect
+  !
+  !=======================================================================
+  !-----------------------------------------------------------------------
+  !   Declarations:
+  !   -------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+
+  !   Arguments:
+  !   ----------
+
+  REAL :: vcov(ijb_v:ije_v, llm), ucov(ijb_u:ije_u, llm)
+  REAL :: teta(ijb_u:ije_u, llm)
+  REAL :: massebx(ijb_u:ije_u, llm), masseby(ijb_v:ije_v, llm)
+  REAL :: w(ijb_u:ije_u, llm)
+  REAL :: dv(ijb_v:ije_v, llm), du(ijb_u:ije_u, llm)
+  REAL :: dteta(ijb_u:ije_u, llm)
+  !   Local:
+  !   ------
+
+  REAL :: wsur2(ijb_u:ije_u)
+  REAL :: unsaire2(ijb_u:ije_u), ge(ijb_u:ije_u)
+  REAL :: deuxjour, ww, gt, uu, vv
+
+  INTEGER :: ij, l, ijb, ije
+  EXTERNAL  SSUM
+  REAL :: SSUM
+
+
+
+  !-----------------------------------------------------------------------
+  !   2. Calculs preliminaires:
+  !   -------------------------
+
+  IF (conser.AND.1==0)  THEN
+    deuxjour = 2. * daysec
+
+    DO   ij = 1, ip1jmp1
+      unsaire2(ij) = unsaire(ij) * unsaire(ij)
+    END DO
+  END IF
+
+
+  !------------------  -yy ----------------------------------------------
+  !   .  Calcul de     u
+
+  !$OMP MASTER
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_nord) ijb = ijb + iip1
+  if (pole_sud)  ije = ije - iip1
+
+  DO ij = ijb, ije
+    du2(ij, 1) = 0.
+    du1(ij, llm) = 0.
+  ENDDO
+
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud)  ije = ij_end - iip1
+
+  DO ij = ijb, ije
+    dv2(ij, 1) = 0.
+    dv1(ij, llm) = 0.
+  ENDDO
+
+  ijb = ij_begin
+  ije = ij_end
+
+  DO ij = ijb, ije
+    dteta2(ij, 1) = 0.
+    dteta1(ij, llm) = 0.
+  ENDDO
+  !$OMP END MASTER
+  !$OMP BARRIER
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO  l = 1, llm
+
+    ijb = ij_begin
+    ije = ij_end
+    if (pole_nord) ijb = ijb + iip1
+    if (pole_sud)  ije = ije - iip1
+
+    ! DO    ij     = iip2, ip1jmp1
+    !    uav(ij,l) = 0.25 * ( ucov(ij,l) + ucov(ij-iip1,l) )
+    ! ENDDO
+
+    ! DO    ij     = iip2, ip1jm
+    !    uav(ij,l) = uav(ij,l) + uav(ij+iip1,l)
+    ! ENDDO
+
+    DO    ij = ijb, ije
+
+      uav(ij, l) = 0.25 * (ucov(ij, l) + ucov(ij - iip1, l)) &
+              + 0.25 * (ucov(ij + iip1, l) + ucov(ij, l))
+    ENDDO
+
+    if (pole_nord) then
+      DO      ij = 1, iip1
+        uav(ij, l) = 0.
+      ENDDO
+    endif
+
+    if (pole_sud) then
+      DO      ij = 1, iip1
+        uav(ip1jm + ij, l) = 0.
+      ENDDO
+    endif
+
+  ENDDO
+  !$OMP END DO
+  ! CALL write_field3d_p('uav',reshape(uav,(/iip1,jjp1,llm/)))
+
+  !------------------  -xx ----------------------------------------------
+  !   .  Calcul de     v
+
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud)  ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO  l = 1, llm
+
+    DO    ij = ijb + 1, ije
+      vav(ij, l) = 0.25 * (vcov(ij, l) + vcov(ij - 1, l))
+    ENDDO
+
+    DO    ij = ijb, ije, iip1
+      vav(ij, l) = vav(ij + iim, l)
+    ENDDO
+
+    DO    ij = ijb, ije - 1
+      vav(ij, l) = vav(ij, l) + vav(ij + 1, l)
+    ENDDO
+
+    DO    ij = ijb, ije, iip1
+      vav(ij + iim, l) = vav(ij, l)
+    ENDDO
+
+  ENDDO
+  !$OMP END DO
+  ! CALL write_field3d_p('vav',reshape(vav,(/iip1,jjm,llm/)))
+
+  !-----------------------------------------------------------------------
+  !$OMP BARRIER
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llmm1
+
+
+    ! ......   calcul de  - w/2.    au niveau  l+1   .......
+    ijb = ij_begin
+    ije = ij_end + iip1
+    if (pole_sud)  ije = ij_end
+
+    DO ij = ijb, ije
+      wsur2(ij) = - 0.5 * w(ij, l + 1)
+    END DO
+
+
+    ! .....................     calcul pour  du     ..................
+
+    ijb = ij_begin
+    ije = ij_end
+    if (pole_nord) ijb = ijb + iip1
+    if (pole_sud)  ije = ije - iip1
+
+    DO ij = ijb, ije - 1
+      ww = wsur2 (ij) + wsur2(ij + 1)
+      uu = 0.5 * (ucov(ij, l) + ucov(ij, l + 1))
+      du1(ij, l) = ww * (uu - uav(ij, l)) / massebx(ij, l)
+      du2(ij, l + 1) = ww * (uu - uav(ij, l + 1)) / massebx(ij, l + 1)
+    END DO
+
+    ! .................    calcul pour   dv      .....................
+    ijb = ij_begin
+    ije = ij_end
+    if (pole_sud)  ije = ij_end - iip1
+
+    DO ij = ijb, ije
+      ww = wsur2(ij + iip1) + wsur2(ij)
+      vv = 0.5 * (vcov(ij, l) + vcov(ij, l + 1))
+      dv1(ij, l) = ww * (vv - vav(ij, l)) / masseby(ij, l)
+      dv2(ij, l + 1) = ww * (vv - vav(ij, l + 1)) / masseby(ij, l + 1)
+    END DO
+
+    !
+
+    ! ............................................................
+    ! ...............    calcul pour   dh      ...................
+    ! ............................................................
+
+    !                   ---z
+    !   calcul de  - d( teta  * w )      qu'on ajoute a   dh
+    !               ...............
+    ijb = ij_begin
+    ije = ij_end
+
+    DO ij = ijb, ije
+      ww = wsur2(ij) * (teta(ij, l) + teta(ij, l + 1))
+      dteta1(ij, l) = ww
+      dteta2(ij, l + 1) = ww
+    END DO
+
+    ! ym ---> conser a voir plus tard
+
+    ! IF( conser)  THEN
+    !
+    !    DO 17 ij = 1,ip1jmp1
+    !    ge(ij)   = wsur2(ij) * wsur2(ij) * unsaire2(ij)
+    !  17    CONTINUE
+    !    gt       = SSUM( ip1jmp1,ge,1 )
+    !    gtot(l)  = deuxjour * SQRT( gt/ip1jmp1 )
+    !  END IF
+
+  END DO
+  !$OMP END DO
+
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_nord) ijb = ijb + iip1
+  if (pole_sud)  ije = ije - iip1
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('du_bis', du)
+  END IF
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije - 1
+      du(ij, l) = du(ij, l) + du2(ij, l) - du1(ij, l)
+    ENDDO
+
+    DO   ij = ijb + iip1 - 1, ije, iip1
+      du(ij, l) = du(ij - iim, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('du1', du1)
+    CALL WriteField_u('du2', du2)
+    CALL WriteField_u('du_bis', du)
+  END IF
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud)  ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije
+      dv(ij, l) = dv(ij, l) + dv2(ij, l) - dv1(ij, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+  ijb = ij_begin
+  ije = ij_end
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije
+      dteta(ij, l) = dteta(ij, l) + dteta2(ij, l) - dteta1(ij, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  RETURN
+END SUBROUTINE advect_new_loc
